#target bridge
// Mauro Dalfreddo Software
// (c) Copyright 2011 www.maurodalfreddo.it
// All Rights Reserved
//
// All Software scripts are released AS IS with no warranty implied or granted. 
//

// MDExtension-Script.jsx
$.level = 0;

if ( BridgeTalk.appName == "bridge" )  { // only load into bridge

var MDExtension = {}; // namespace for this script
try {
	MDExtension.scriptInfo = new ScriptManager.ScriptInfo();
	MDExtension.scriptInfo.set( "name", "MDExtension" );
	MDExtension.scriptInfo.set( "description", "Extension script" );
	MDExtension.scriptInfo.set( "help", "Extension script" );
	MDExtension.scriptInfo.set( "author", "Mauro Dalfreddo" );	
	MDExtension.scriptInfo.set( "copyright", "(c) Copyright 2011 Mauro Dalfreddo Software, all rights reserved" );
	MDExtension.scriptInfo.set( "version", "1.0" );
	MDExtension.scriptInfo.set( "date", "04-02-2011" );
	MDExtension.scriptInfo.set( "website", "http://www.maurodalfreddo.it" );	
} catch ( e ) {
}

MDExtension.run = function( menu )  {
	var mode = null;
	switch ( menu.text ) {
		case "Align Meta" : {
			mode = "AlignMeta";
			break;
		}
		case "Display Meta" : {
			mode = "DisplayMeta";
			break;
		}
		case "Preview operations" : {
			mode = "Preview";
			break;
		}		
	}	
	try {
	MDExtension.execute( mode, menu.text );	
		return true;
	} catch (e) {
		alert(e);
	}
}
MDExtension.displayMeta = function(thumb) {
	if ( AdobeLibrary1.isFile( thumb ) && thumb.hasMetadata ) {
			var meta="";
			var md = thumb.synchronousMetadata;
			
			for ( var n = 0; n < MdNs.namespaces.keyList.length; n++ ) {
				
				var ns = MdNs.namespaces.get( MdNs.namespaces.keyList[ n ] );						
				var nsmeta="";
				for ( var j = 0; j < ns.children.length; j++ ) 	{
					var val = ns.children[ j ].getValue(md);
					if (val!=null && val != "")
						nsmeta += ", " + ns.children[ j ].property + "="+ val;
					}
				if (nsmeta != "")
					meta += "\n["+ns.common+"]: " +nsmeta;
					
			}
			$.writeln("Metadata of "+thumb.path+": "+meta);								
			$.writeln("Attributes of "+thumb.path+": rating="+thumb.rating+" label="+thumb.label+" rotation="+thumb.rotation);					
			alert("Metadata of "+thumb.path+": "+meta+"\n\nAttributes of "+thumb.path+": rating="+thumb.rating+" label="+thumb.label+" rotation="+thumb.rotation);
		 } 
		 
	
}
MDExtension.copyMetaTo = function( ths, thd ) {
	thd.rating = ths.rating;
	thd.label = ths.label;
	
	var mds = ths.synchronousMetadata;
	mds.namespace = "http://purl.org/dc/elements/1.1/";
	var mdd = thd.synchronousMetadata;
	mdd.namespace = "http://purl.org/dc/elements/1.1/";
	 
	var xmp = new XMPMeta(mdd.serialize());
	try{
        xmp.deleteProperty(XMPConst.NS_DC,'subject');
        for(var i=0;i<mds.subject.length;i++)
			xmp.appendArrayItem(XMPConst.NS_DC, "subject", mds.subject[i], 0,XMPConst.PROP_IS_ARRAY);
    } catch(e){
		alert(ths.name+" : Bad Keyword : "+mds.subject);
	}
	var updatedPacket = xmp.serialize(XMPConst.SERIALIZE_OMIT_PACKET_WRAPPER | XMPConst.SERIALIZE_USE_COMPACT_FORMAT);
		
	// $.writeln(updatedPacket);
	thd.metadata = new Metadata(updatedPacket);
    
	$.writeln("Metadata of "+ths.path+" and "+thd.path+" syncronyzed");					
	    	
	
}
MDExtension.LoadXMPLibrary = function() {
	// Load the XMP Script library
	if( xmpLib == undefined ) 
	{
		if( Folder.fs == "Windows" )
		{
			var pathToLib = Folder.startup.fsName + "/AdobeXMPScript.dll";
		} 
		else 
		{
			var pathToLib = Folder.startup.fsName + "/AdobeXMPScript.framework";
		}		
		var libfile = new File( pathToLib );
		var xmpLib = new ExternalObject("lib:" + pathToLib );
	}
}
MDExtension.execute = function( mode, prettyMode ) {

	MDExtension.LoadXMPLibrary();

	app.synchronousMode =true;	
	
	var thumbs = getBridgeThumbnails();
	if (thumbs.length ==0) {
		alert( "No Valid Files Selected" );
		return;
	}
	var iCr2=0;
	var iJpg=0;
	var iCr2sel=0;
	for ( var i = 0; i < thumbs.length; i++ ) {
		 
		 if (mode == "DisplayMeta")
			MDExtension.displayMeta(thumbs[ i ]);
					
		 if (mode == "AlignMeta" || mode == "Preview") {		
			var str = new String( thumbs[i].path );
			if (str.endsWith(".CR2") || str.endsWith(".cr2")) {
				iCr2sel++;
			}
			if (str.endsWith(".JPG") || str.endsWith(".jpg")) {
				iJpg++;
				var filecr2 = str.replace( /[.](JPG|jpg)$/g, '.CR2' )
				var f = new File(filecr2);				
				if(f.exists) iCr2++;
				if(f.exists && mode == "AlignMeta") {				
					var th1 = new Thumbnail(f);
					//MDExtension.displayMeta(th1);
					$.writeln("Processing "+th1.path);				
					if (!th1.locked){
						MDExtension.copyMetaTo(thumbs[i],th1);										
					}
				}
			}
		}
	}
	if ( mode == "Preview") {
		alert("The Metadata of "+ iCr2+ " RAW files will be aligned"+
		(iCr2sel>0?"\n\nWarning: You are selecting "+iCr2sel+" CR2 files; only raw files of jpgs selected will be processed.":""));
	}
}
createMenu( "menu", "Scripts", "after Tools", "scripts" );
createMenu( "menu", "Canon RAW", "at the end of scripts", "scripts/MDExtension", MDExtension.run );
createMenu( "command", "Preview operations", "at the end of scripts/MDExtension", "scripts/MDExtension/preview", MDExtension.run );
createMenu( "command", "Align Meta", "at the end of scripts/MDExtension", "scripts/MDExtension/align", MDExtension.run );
createMenu( "command", "Display Meta", "at the end of scripts/MDExtension", "scripts/MDExtension/display", MDExtension.run );


// report loading to the ScriptManager
try {
	ScriptManager.reportLoading( MDExtension.scriptInfo );
} catch ( e ) {
}

}
